/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


EXPORTED_SYMBOLS.push("createItemSubType");
function createItemSubType(name, listEntry, superType)
{
    var superTypes = Array.prototype.slice.call(arguments, 2);
    var constructor = function()
    {
        for each (let type in superTypes)
            type.apply(this);
    };

    var extendFunction = extend;
    for each (let type in superTypes)
    {
        extendFunction(constructor, type);
        extendFunction = extendMixIn;
    }

    listEntry.modelType = constructor;
    constructor.prototype._listEntry = listEntry;
    AddSubtypeV1(listEntry);

    this[name] = constructor;
    EXPORTED_SYMBOLS.push(name);
}

createItemSubType("ttStartupScreen", {
    xmlTag : "startupscreen",
    tocTag : "Image",
    tocSubtype : "startupscreen",
    priority : 80,
    itemtypeEnum : CI.ttIItem.kItemStartupScreen,
    idlType : CI.ttINavItem
}, ttImageItem);

createItemSubType("ttSuspendScreen", {
    xmlTag : "suspendscreen",
    tocTag : "Image",
    tocSubtype : "suspendscreen",
    priority : 70,
    itemtypeEnum : CI.ttIItem.kItemSuspendScreen,
    idlType : CI.ttINavItem
}, ttImageItem);

createItemSubType("ttHomeSymbol", {
    xmlTag : "homesymbol",
    tocTag : "Image",
    tocSubtype : "homesymbol",
    priority : 89,
    itemtypeEnum : CI.ttIItem.kItemHomeImage,
    idlType : CI.ttINavItem
}, ttImageItem);

createItemSubType("ttFavouriteSymbol", {
    xmlTag : "favouritesymbol",
    tocTag : "Image",
    tocSubtype : "favouritesymbol",
    priority : 88,
    itemtypeEnum : CI.ttIItem.kItemFavouriteImage,
    idlType : CI.ttINavItem
}, ttImageItem);

createItemSubType("ttBuddySymbol", {
    xmlTag : "buddysymbol",
    tocTag : "Image",
    tocSubtype : "buddysymbol",
    priority : 87,
    itemtypeEnum : CI.ttIItem.kItemBuddyImage,
    idlType : CI.ttINavItem
}, ttImageItem);

createItemSubType("ttCarSymbol", {
    xmlTag : "carsymbol",
    tocTag : "Image",
    tocSubtype : "carsymbol",
    priority : 90,
    itemtypeEnum : CI.ttIItem.kItemCarSymbol,
    idlType : CI.ttINavItem
}, ttImageItem);

createItemSubType("ttArrivalSound", {
    xmlTag : "arrivalsound",
    tocTag : "Sound",
    tocSubtype : "arrivalsound",
    priority : 55,
    itemtypeEnum : CI.ttIItem.kItemArrivalSound,
    idlType : CI.ttINavItem
}, ttSoundItem);

createItemSubType("ttWarningSound", {
    xmlTag : "warningsound",
    tocTag : "Sound",
    tocSubtype : "warningsound",
    priority : 60,
    itemtypeEnum : CI.ttIItem.kItemWarningSound,
    idlType : CI.ttINavItem
}, ttSoundItem);

createItemSubType("ttStartupSound", {
    xmlTag : "startupsound",
    tocTag : "Sound",
    tocSubtype : "startupsound",
    priority : 54,
    itemtypeEnum : CI.ttIItem.kItemStartupSound,
    idlType : CI.ttINavItem
}, ttSoundItem);

createItemSubType("ttShutdownSound", {
    xmlTag : "shutdownsound",
    tocTag : "Sound",
    tocSubtype : "shutdownsound",
    priority : 53,
    itemtypeEnum : CI.ttIItem.kItemShutdownSound,
    idlType : CI.ttINavItem
}, ttSoundItem);

createItemSubType("ttMessageReceived", {
    xmlTag : "messagereceived",
    tocTag : "Sound",
    tocSubtype : "messagereceived",
    priority : 27,
    itemtypeEnum : CI.ttIItem.kItemMessageReceived,
    idlType : CI.ttINavItem
}, ttSoundItem);

createItemSubType("ttRingtone", {
    xmlTag : "ringtone",
    tocTag : "Sound",
    tocSubtype : "ringtone",
    priority : 5,
    itemtypeEnum : CI.ttIItem.kItemRingtone,
    idlType : CI.ttINavItem
}, ttSoundItem);

createItemSubType("ttTraffic", {
    xmlTag : "traffic",
    tocTag : "Poi",
    priority : 13,
    itemtypeEnum : CI.ttIItem.kItemPOIs,
    idlType : CI.ttINavItem
}, ttNoInstallSubscription);

createItemSubType("ttRDSTMCTraffic", {
    xmlTag : "rdstmcsubscription",
    tocTag : "RDSTMCSubscription",
    priority : 14,
    itemtypeEnum : CI.ttIItem.kItemRDSTMCSubscription,
    idlType : CI.ttINavItem
}, ttNavItem, ttSubscription);
ttRDSTMCTraffic.prototype.importFromXML = function()
{
    ttNavItem.prototype.importFromXML.apply(this, arguments);
    ttSubscription.prototype.importSubscriptionFromXML.apply(this, arguments);
};
ttRDSTMCTraffic.prototype.__defineGetter__("displayCategory", function() "traffic");

createItemSubType("ttSatImage", {
    xmlTag : "satimage",
    tocTag : "SatelliteImage",
    priority : 120,
    itemtypeEnum : CI.ttIItem.kItemSatImages,
    idlType : CI.ttINavItem
}, ttNavItem);

createItemSubType("ttTrail", {
    xmlTag : "trail",
    tocTag : "File",
    priority : 125,
    itemtypeEnum : CI.ttIItem.kItemTrail,
    idlType : CI.ttINavItem
}, ttNavItem);

createItemSubType("ttItinerary", {
    xmlTag : "itinerary",
    tocTag : "Itinerary",
    priority : 125,
    itemtypeEnum : CI.ttIItem.kItemItinerary,
    idlType : CI.ttINavItem
}, ttNavItem);

createItemSubType("ttEphemeris", {
    xmlTag : "ephemeris",
    tocTag : "Ephemeris",
    priority : 50,
    itemtypeEnum : CI.ttIItem.kItemEphemeris,
    idlType : CI.ttINavItem
}, ttNavItem);

createItemSubType("ttHtmlPack", {
    xmlTag : "htmlpack",
    tocTag : "HtmlPack",
    priority : 9,
    itemtypeEnum : CI.ttIItem.kItemHtmlPack,
    idlType : CI.ttINavItem
}, ttNavItem);

createItemSubType("ttPhoneDB", {
    xmlTag : "phonedb",
    tocTag : "PhoneDatabase",
    priority : 40,
    itemtypeEnum : CI.ttIItem.kItemPhoneDatabase,
    idlType : CI.ttINavItem
}, ttNavItem);

createItemSubType("ttZipcode", {
    xmlTag : "zipcode",
    tocTag : "ZipCode",
    priority : 110,
    itemtypeEnum : CI.ttIItem.kItemZipcode,
    idlType : CI.ttINavItem
}, ttNavItem);

createItemSubType("ttColorScheme", {
    xmlTag : "colorscheme",
    tocTag : "ColorScheme",
    priority : 100,
    itemtypeEnum : CI.ttIItem.kItemColorScheme,
    idlType : CI.ttINavItem
}, ttNavItem);

createItemSubType("ttPartialUpdate", {
    xmlTag : "partialupdate",
    tocTag : "PartialUpdate",
    priority : -10,
    itemtypeEnum : CI.ttIItem.kItemPartialUpdate,
    idlType : CI.ttINavItem
}, ttNavItem);

createItemSubType("ttMapASR", {
    xmlTag : "mapasr",
    tocTag : "MapAsr",
    priority : -20,
    itemtypeEnum : CI.ttIItem.kItemMapAsr,
    idlType : CI.ttINavItem
}, ttNavItem);

createItemSubType("ttUnknownItemType", {
    xmlTag : "content",
    tocTag : "File",
    itemtypeEnum : CI.ttIItem.kItemTypeUnknown,
    idlType : CI.ttIItem
}, ttNavItem);

createItemSubType("ttCombiProduct", {
    xmlTag : "combiproduct",
    tocTag : "File",
    itemtypeEnum : CI.ttIItem.kItemTypeUnknown,
    idlType : CI.ttIItem
}, ttItem, ttSubscription);
ttCombiProduct.importFromXML = function()
{
    ttItem.prototype.importFromXML.apply(this, arguments);
    ttSubscription.prototype.importSubscriptionFromXML.apply(this, arguments);
}

createItemSubType("ttExtension", {
    xmlTag : "extension",
    tocTag: "Extension",
    priority : 20,
    extensionManagerType : CI.nsIUpdateItem.TYPE_EXTENSION
}, ttAddon);

createItemSubType("ttMapSubscription", {
    xmlTag : "mapsubscription",
    tocTag: "MapSubscription",
    priority: 160
}, ttNoInstallSubscription);

createItemSubType("ttEntryFee", {
    xmlTag : "entryfee",
    tocTag: "EntryFee",
    priority: 160
}, ttItem);

createItemSubType("ttLiveService", {
    xmlTag : "liveservices",
    tocTag : "File",
    priority : 150,
    itemtypeEnum : CI.ttIItem.kItemTypeUnknown,
    idlType : CI.ttIItem
}, ttNoInstallSubscription);
