/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function MessageBox()
{
    ttDialog.call(this, "footer");
}
MessageBox.prototype =
{
    _pageType : null,
    SEVERITY_INFORMATIVE : 0,
    SEVERITY_WARNING : 1,

    onLoad : function(args)
    {
        this.setTextFields(args.title, args.msg, args.urlid, args.urllabel);
        this.setButtons(args.showOK, args.showCancel, args.labelOK, args.labelCancel);
        this.setPageType(args.pageType, args.defaultValue, args.severity, args.customID);
    },
    setPageType : function(pageType, promptDefaultValue, severity, customID)
    {
        this._pageType = pageType;
        switch (pageType)
        {
            case ("alert") :
                this.setIcon(this.SEVERITY_INFORMATIVE, severity, customID);
                break;
            case ("confirm") :
                this.setIcon(this.SEVERITY_WARNING, severity, customID);
                break;
            case ("prompt") :
                this.setIcon(this.SEVERITY_INFORMATIVE, severity, customID);
                var prompt = E("prompt");
                prompt.hidden = false;
                prompt.value = promptDefaultValue;
                prompt.select();
                prompt.focus();
                break;
        };
    },

    setIcon : function (defaultSeverity, reqSeverity, customID)
    {
        var severity = (reqSeverity != null) ? reqSeverity : defaultSeverity;
        if (customID)
            document.documentElement.id = customID;
        else
        {
            var severityIcons = ["alert-header", "confirm-header"];
            assert(severity >= 0 && severity < severityIcons.length, "invalid value used for severity");
            E("message-header").setAttribute("class", severityIcons[severity]);
        }

    },

    setTextFields : function (title, message, urlid, urllabel)
    {
        var appname = "TomTom HOME";
        try {
            appname = getStringBundle("chrome://branding/locale/brand.properties")
                        .GetStringFromName("brandFullName");
        } catch (e) { unimportantError(e); }
        document.title = title + " - " + appname;

        E("message-header").setAttribute("title", title);

        E("message").appendChild(
            document.createTextNode(message));
        
        if(urlid && urllabel)
        {
            var link = document.createElement("ttlink");
            link.setAttribute("type", "webid");
            link.setAttribute("urlid", urlid);
            link.setAttribute("label", urllabel);
            E("message").appendChild(link);
        }
    },

    setButtons : function (showOK, showCancel, labelOK, labelCancel)
    {
        var footer = E("footer");
        footer.getLeftButton().hidden = !showCancel;
        footer.getMiddleButton().hidden = true;
        footer.getRightButton().hidden = !showOK;

        if (labelCancel)
            footer.getLeftButton().label = labelCancel;
        if (labelOK)
            footer.getRightButton().label = labelOK;
    },


    doOK : function()
    {
        if (this._pageType == "prompt")
        {
            this.close(E("prompt").value);
        }
        else
            this.close(true);
    },

    __end : null
}
extend(MessageBox, ttDialog);
var dialog = new MessageBox();
