/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


var gItem = null;
function MoreInfoDialog()
{
    ttDialog.call(this, "footer");
    this._countriesBundle = getStringBundle("chrome://tthome/locale/ttlocalelist/countries.properties");
}
MoreInfoDialog.prototype =
{
    _countriesBundle : null,
    _sb : null,
    _item : null,
    _ignoreRatingChange : false,

    onLoad : function(params)
    {
        this._itemNode = params.item;
        this._item = params.item._model;
        gItem = this._item;
        this._sb = E("moreInfo-stringbundle");

        this.setItem(params.item._model);
        this.setAcceptButtonLabel(params.acceptButtonLabel);
    },

    setItem : function(item)
    {
        var sb = this._sb;

        E("contentTypeOverlay").setAttribute("itemtype", item.typeID);

        var title = item.name;
        const kMaxTitleLength = 40;
        if (title.length > kMaxTitleLength)
            title = title.substr(0, kMaxTitleLength - 1) + "...";
        E("moreinfo-title").setAttribute("title",
                sb.getFormattedString("title", [title]));
        E("info-title").setAttribute("value", item.name);

        if (item.description)
        {
            E("info-text").appendChild(document.createTextNode(item.description));
        }
        else
        {
            E("info-text").value = sb.getString("noDescription");
        }

        if (item.tags)
        {
            E("tags").textContent = item.tags;
            E("tags-box").hidden = false;
        }

        var img = E("info-preview");
        if (item.preview)
        {
            img.src = item.preview.url;
        }
        else
        {
            img.src = "skin:///images/preview-missing.png";
        }

        E("info-locationtype").appendChild(document.createTextNode(this.locationToText(item.locationType)));

        E("info-version").setAttribute("value", item.version ? item.version : sb.getString("noVersion"));

        let hItem = (item.mapType == 2 || this._itemNode.nextSibling && this._itemNode.nextSibling._model.mapType == 2)
        if (item instanceof ttMap && hItem && item.mapType !== 0 && !this.isMapOnComputer(item))
        {
            
            let mapName = item.name;
            if (item.mapType == 1)
            {
                mapName = this._itemNode.nextSibling._model.name;
            }
            E("info-note").appendChild(document.createTextNode(sb.getFormattedString("mapZone", [mapName])));
            E("info-note").hidden = false;
            
            let regions = item.regions;
            if (item.mapType == 1)
                regions = this._itemNode.nextSibling._model.regions;

            if (regions)
            {
                E("info-contents").appendChild(document.createTextNode(sb.getFormattedString("mapZoneContains", [this.convertToCountryNames(regions)])));
            }

            var link = document.createElement("description");
            link.setAttribute("value", sb.getString("mapZoneChange"));
            link.setAttribute("class", "link");
            var me = this;
            link.onclick = function () 
            {
                me.changeMapZone();
            }

            E("info-contents").appendChild(link);

            E("info-contents").hidden = false;
        }

        if (item.lastModification && item.isSharing)
        {
            E("info-lastModification").setAttribute("value", item.lastModification.toLocaleDateString());
            E("lastModification-row").hidden = false;
        }

        var author = E("author");
        if (item.authorName)
            author.value = sb.getString("author") + ": " + item.authorName;
        else
            author.hidden = true;

        var dev = (gApplication.deviceManager.activeDevice || gApplication.deviceManager.lastDevice);
        if (dev && item.isRateable)
        {
            E("feedback-box").hidden = false;
            this.setSharingUI(item.idurl);

            this.setAverageRating(item.rating, item.votes);
            E("rating-row").hidden = false;
        }

        if (item.price)
            E("info-price").setAttribute("value",  item.price.displayString());
        else
            E("info-price").parentNode.hidden = true;

        E("info-size").setAttribute("value", ttItem.sizeBytesToActualDisplay(item.size));

        if (item.locationType < 4)
        {
            E("info-location").value = sb.getString("location");

            var location = E("item-files");
            for (var i = 0; i < item.locations.length; i ++)
            {
                var fileLabel = document.createElement("label");
                fileLabel.setAttribute("crop", "end");
                fileLabel.setAttribute("value", item.locations[i].url.path);
                location.appendChild(fileLabel);
            }
        }
        if (item instanceof ttNavItem)
        {
            if (item.locationType == 1)
            {
                if (item.canUseOnThisDevice() != 0)
                {
                    var compatError = E("compatibility-error");
                    var compatInfo = E("compatibility-info");
                    compatError.textContent = sb.getString("notUsableItemError");
                    compatError.hidden = false;
                    compatInfo.textContent = sb.getString("notUsableItemInfo");
                    compatInfo.hidden = false;
                }
            }
            else if (gApplication.deviceManager.activeDevice)
            {
                if (item.canInstallOn(dev) != 0)
                {
                    var compatError = E("compatibility-error");
                    compatError.textContent = sb.getString("notInstallableItemError");
                    compatError.hidden = false;
                }
            }
        }
    },
isMapOnComputer : function (item)
    {
        let zoneItem = this._itemNode.nextSibling;
        if ((item.locationType === 2 || item.locationType === 3) || (zoneItem && (zoneItem._model.locationType === 2 || zoneItem._model.locationType === 3)))
            return true;
        else
            return false;
    },
    setAcceptButtonLabel : function (aLabel)
    {
        var acceptBtn = E("footer").getRightButton();
        if (aLabel)
        {
            acceptBtn.label = aLabel;
            acceptBtn.setAttribute("oncommand", "dialog.acceptItemAction();");
            acceptBtn.notvisible = false;
        }
    },

    locationToText : function (location, type)
    {
        if (location == 1)
            return this._sb.getString("onDevice");
        if (location == 2)
            return this._sb.getString("onComputer");
        if (location == 3)
            return this._sb.getString("onCD");
        if (location == 4 || location == 6)
            return this._sb.getString("onServer");
        throw new NotReached();
    },
convertToCountryNames : function (regions)
    {
        var regionArray = regions;
        for (let i = 0; i < regionArray.length; i++) 
        {
            let region = regionArray[i];
            let resolvedRegion = region;
            try {
                resolvedRegion = this._countriesBundle.GetStringFromName(region.toString());
            } 
            catch (e) {
            }
            if(resolvedRegion)
            {
                regionArray[i] = resolvedRegion;
            }
            else
            {
                regionArray[i] = region;
            }
        }
        return regionArray.join(", ");
    },
setSharingUI : function (idurl)
    {
        var dev = (gApplication.deviceManager.activeDevice || gApplication.deviceManager.lastDevice);
        var uploadBody = <contentidlist><content idurl={idurl}/></contentidlist>;
        var params = { deviceSerial: dev.serial, deviceCode: dev.deviceCode };

        var errorCallback = function (e)
        {
            unimportantError(e);
            if (e.code == -5)
                E("feedback-box").hidden = true;
        };

        var me = this;
        dialog.networkCall(rpc.call("sharing", "getContentRatings",
            params, <getcontentratings/>.appendChild(uploadBody), RPC.METHOD_POST,
            function (aResult)
            {
                var ucContent = aResult.contentidlist.content.(@idurl == idurl);
                try {
                    if (ucContent.@myRating)
                    {
                        var myRating = Math.round(makeSafe.rangeInt(ucContent.@myRating, 0, 5000) / 1000) * 1000;
if (myRating != 0)
                        {
                            me._ignoreRatingChange = true;
                            try {
                                E("rating-list").value = myRating;
                                E("rating-result").setAttribute("stars", myRating);
                                E("rating-deck").selectedIndex = 1;
                            } finally {
                                me._ignoreRatingChange = false;
                            }
                        }
                    }
                    if (ucContent.@rating && ucContent.@votes)
                    {
                        var average = makeSafe.rangeInt(ucContent.@rating, 0, 5000);
                        var votes = makeSafe.integer(ucContent.@votes);
                        me.setAverageRating(average, votes);
                    }
                } catch (e) { unimportantError(e); }
            },
            errorCallback));

        dialog.networkCall(rpc.call("sharing", "getContentReports",
            params, <getcontentreports/>.appendChild(uploadBody), RPC.METHOD_POST,
            function (aResult)
            {
                var ucContent = aResult.contentidlist.content.(@idurl == idurl);
                try {
                    if (ucContent.@reports && makeSafe.integer(ucContent.@reports) > 0)
                        E("ban-desc").hidden = false;
                } catch (e) { unimportantError(e); }
            },
            errorCallback));
    },

    setAverageRating : function (average, votes)
    {
        if (average)
        {
            var rating = E("rating-current");
            rating.setAttribute("stars", Math.round(average / 250) * 250);
            rating.hidden = false;
            E("info-rating").value = this._sb.getFormattedString("noOfVotes", [ votes ]);
        }
        else
        {
            E("info-rating").value = this._sb.getString("noRatingAvailable");
        }
    },

    rateItem : function (aMenulist)
    {
        if (this._ignoreRatingChange)
            return;

        var dev = (gApplication.deviceManager.activeDevice || gApplication.deviceManager.lastDevice);

        if (!dev || aMenulist.selectedIndex == 0)
            return;

        var myRating = makeSafe.rangeInt(aMenulist.value, 1000, 5000);

        var me = this;
        top.gMainWindow.dialogs.openDialogAsWindow(
            "chrome://tthome/content/ui/dialogs/moreinfo/rating.xul",
            { item : me._item, rating : myRating },
            null,
            function (success)
            {
                if (!success)
                {
                    aMenulist.selectedIndex = 0;
                    return;
                }
                E("rating-result").setAttribute("stars", myRating);
                E("rating-deck").selectedIndex = 1;
            }, false, top);
    },

    reportItem : function (aMenulist)
    {
        var dev = (gApplication.deviceManager.activeDevice || gApplication.deviceManager.lastDevice);

        if (!dev || aMenulist.selectedIndex == 0)
            return;

        var me = this;
        top.gMainWindow.dialogs.openDialogAsPage(
            "chrome://tthome/content/ui/dialogs/moreinfo/inappropriate.xul",
            { item : me._item, reasonCategory : aMenulist.label },
            null,
            function (success)
            {
                if (!success)
                {
                    aMenulist.selectedIndex = 0;
                    return;
                }
                E("ban-desc").hidden = false;
            }, false, top);
    },
    
    changeMapZone : function()
    {
        this._item.changeMapZone = true;
        this.cancel();
    },
    
    cancel : function ()
    {
        dialog.close(false);
    },

    acceptItemAction : function ()
    {
        dialog.close(true);
    },

    __end : null
};
extend(MoreInfoDialog, ttDialog);
var dialog = new MoreInfoDialog();
