/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


var MapSubscription =
{
    _stringBundle : null,

    get stringBundle()
    {
        if (!this._stringBundle)
            this._stringBundle = getStringBundle("chrome://tthome/locale/ui/mainwin/mapSubscription.properties");
        return this._stringBundle;
    },
offerMapSubscriptionDeal : function(showExtensions, entryPoint)
    {
        if (!gApplication.deviceManager.activeDevice.activeMap)
        {
            throw new Exception(null, "MapSubscription/OfferMapSubscriptionDeal/NoActiveMap");
        }

        var me = this;
        return this._queryMapSubscription(entryPoint, function(aResult)
            {
                if (aResult.contentlist.length() != 0)
                {
                    var subscriptionItems = gApplication.itemFactory.createItemListFromServer(aResult);
                    var cartItemsIDs = [ idurl for (idurl in (i.idurl for each (i in gApplication.cart.contentsFlat))) ];
                    var filteredItems = [];
                    for each (var subsItem in subscriptionItems)
                    {
                        if (cartItemsIDs.indexOf(subsItem.idurl) == - 1)
                        {
                            if (subsItem.typeID == "mapsubscription")
                                filteredItems.push(subsItem);
                            else
                            {
                                var dependenciesIDs = [ dep.idstr for each (dep in subsItem.dependencies) ];
                                for each (var dep in dependenciesIDs)
                                {
                                    if (cartItemsIDs.indexOf(dep) == -1)
                                        filteredItems.push(subsItem);
                                }
                            }
                        }
                    }

                    if (filteredItems.length > 0)
                    {
                        var propertyString;
                        var renewal = makeSafe.bool(aResult.@renewal);

                        if (!renewal)
                        {
                            switch (entryPoint)
                            {
                                case "lmg":
                                    propertyString = "mapSubscription.LMG";
                                    break;
                                case "statusindicator":
                                    propertyString = "mapSubscription.indicator";
                                    break;
                                case "mapshop":
                                    propertyString = filteredItems.some(function(item) item.typeID == "entryfee") ? "mapSubscription.oldMap" : "mapSubscription.latestMap";
                                    break;
                                default:
                                    throw new NotReached("Unknown entry point: " + entryPoint);
                            }
                        }
                        else
                            propertyString = "mapSubscription";

                        if (!renewal || showExtensions)
                        {
                            ttMessageService().confirm(
                                me.stringBundle.GetStringFromName(propertyString + ".title"),
                                renewal ? me.stringBundle.GetStringFromName("mapSubscription.prompt") : makeSafe.string(aResult.text.text()),
                                me.stringBundle.GetStringFromName(propertyString + ".cancel"),
                                me.stringBundle.GetStringFromName(propertyString + ".continue"),
                                function () {
                                    me._purchaseSubscriptionItems(filteredItems);
                                }, null, MessageService.SEVERITY_INFORMATIVE, null,
                                renewal ? "mapzones" : null,
                                renewal ? me.stringBundle.GetStringFromName("mapSubscription.prompt.label") : null);
                        }
                    }
                }
            }, unimportantError);
    },
_queryMapSubscription : function(entryPoint, successCallback, errorCallback)
    {
        assert(gApplication.deviceManager.activeDevice.activeMap, "Querying for a MapSubscription requires an active map")
        try
        {
            var dev = gApplication.deviceManager.activeDevice;
            var activeMap = gApplication.itemFactory.createItemFromDLL(dev.activeMap);
            var xmlInput = <getMapSubscriptionProposal>
                                <contentidlist>
                                    <content idurl={activeMap.idurlWithVersion} certificate={activeMap.sourceDLL.certificates}/>
                                </contentidlist>
                            </getMapSubscriptionProposal>;

            return rpc.call("shop", "getMapSubscriptionProposal",
                {
                    login : gApplication.login.currentUsername,
                    deviceModel : dev.model.id,
                    navcoreVersion : dev.versionNavCore,
                    origin: entryPoint
                },
                xmlInput, RPC.METHOD_POST | RPC.USE_CACHE,
                successCallback, errorCallback);
        }
        catch (e)
        {
            errorCallback(e);
            return new NoOpCall();
        }
    },

    _purchaseSubscriptionItems : function(items)
    {
        for each (var item in items)
            gApplication.cart.addItem(item);
        top.gMainWindow.loadTask("chrome://tthome/content/ui/task/checkout/checkout.xul");
    }
}
