/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function MapFlavourChoice()
{
    ttPage.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/mapFlavours/mapFlavours.properties");
}
MapFlavourChoice.prototype =
{
    _stringBundle : null,
_maps : null,
_basemap : null,
_devItems : null,
_installedItems : null,
_additionalSizeRequirements : null,
_freeSpaceBuffer : null,
_basemapServerModel : null,
get selectedMap()
    {
        if (this._maps && E("radio_flavours").selectedItem.value in this._maps)
            return this._maps[E("radio_flavours").selectedItem.value];
        return null;
    },

    inputOnLoad : function(params)
    {
        this._maps = params.maps;
        this._basemapServerModel = params.basemapServerModel;
        this._installedItems = params.installedItems;
        this._devItems = params.devItems;
        this._basemap = params.basemap;
        this._additionalSizeRequirements = params.additionalSizeRequirements;
        this._freeSpaceBuffer = params.freeSpaceBuffer;

        var newElement = document.createElement("description");
        let radioGroup = E("radio_flavours");
        let fullmap = this._maps.filter(function(el) el.idstr == el.basemap)[0];

        this._maps.splice(this._maps.indexOf(fullmap), 1);
        let hasMemoryCard = false;
        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
        {
            if (installLocation.physicalType == CI.ttIInstallLocation.kLocationTypeMemoryCard)
            {
                hasMemoryCard = true;
            }
        }

        let isDeviceExpandable = hasMemoryCard || gApplication.deviceManager.activeDevice.hasEmptySDCardSlot;

        if (isDeviceExpandable)
        {
            this._maps.push(fullmap);
        }

        newElement.textContent = this._stringBundle.GetStringFromName("fullmap.message");
        for (let i = 0; i < this._maps.length; i++)
        {
            if (this._maps[i] === fullmap)
            {
                radioGroup.appendItem(this._maps[i].name + " (" + this._stringBundle.GetStringFromName("full.cardneeded") +")", i);
                radioGroup.insertBefore(newElement, radioGroup.getItemAtIndex(i));
            }
            else
            {
                radioGroup.appendItem(this._maps[i].name, i);
            }
        }
        E("basemapName").textContent = this._basemap.name;
        if (radioGroup.itemCount > 0)
            radioGroup.selectedIndex = 0;

        radioGroup.addEventListener("select", makeCallback(this, function(event) {
                this.updateSelected();
            }), false);

        E("spacebar").flavours = true;

        this.updateSelected();
    },
updateSelected : function()
    {
        let item = this.selectedMap;
        let baseMap = this._basemapServerModel;
        let img = E("map-preview-image");

        E("flavourDescription").textContent = item.description;

        if (item.mapzonePreview)
        {
            img.collapsed = false;
            img.src = item.mapzonePreview.url;
        }
        else if (baseMap.mapzonePreview && item.idurl === baseMap.idurl)
        {
            img.collapsed = false;
            img.src = baseMap.mapzonePreview.url;
        }
        else
        {
            img.collapsed = true;
        }
        if (this._updateTimeout)
            clearTimeout(this._updateTimeout);
        this._updateTimeout = setTimeout(makeCallback(this, this._updateSelectedInternal), 0);
    },

    getSpaceToFreeUp : function(data, installLocation)
    {
        let installLocationPath = installLocation.path.path;

        let available = installLocation.sizeInBytesFree;
        let required = this._freeSpaceBuffer + data[installLocationPath];

        if (this._additionalSizeRequirements && installLocationPath in this._additionalSizeRequirements)
            required += this._additionalSizeRequirements[installLocationPath];

        return Math.max(0, required - available);
    },

    _updateTimeout : null,
    _updateSelectedInternal : function()
    {
        this._updateTimeout = null;

        let installLocations = {__proto__: null};
        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
            installLocations[installLocation.path.path] = installLocation;

        let newItems = this._installedItems.concat(this.selectedMap);

        let data = ttNavItem.getInstalledSizeDelta(newItems, null, this._devItems.contents);

        let spacebarData = [];
        for (let installLocationPath in data)
        {
            let installLocation = installLocations[installLocationPath];

            let extra = this.getSpaceToFreeUp(data, installLocation);
            let added = data[installLocationPath] - extra;

            spacebarData.push({
                installLocation: installLocation,
                selected: 0,
                added: Math.max(0, added),
                extra: extra
            });
        }
        E("spacebar").setInstallLocationData(spacebarData);
    },

    result : function()
    {
        return this.selectedMap;
    }
}
extend(MapFlavourChoice, ttPage);
window.page = new MapFlavourChoice();
