/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function MapFlavours()
{
    ttSubTask.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/mapFlavours/mapFlavours.properties");
}
MapFlavours.prototype =
{
    _stringBundle : null,
    name : "mapFlavours",
_zones : null,
_basemap : null,
_installedItems : null,
_devItems : null,
_removableItems : null,
_freeSpaceBuffer : null,
_additionalSizeRequirements : null,
_basemapServerModel : null,

    start : function(params)
    {
        this.networkCall(this._task.needLogin(makeCallback(this, this.getFlavours, params)));
    },

    getFlavours : function(params)
    {
        assert(params && params.item && params.item instanceof ttMap && params.item.basemap,
               "The item passed to the mapFlavours subtask must be a flavoured/favourable ttMap.");
        assert(typeof params.insideInstallFlow != "undefined", "The context for the map flavours task should be specified in the parameters");

        this._basemap = params.item;
        this._installedItems = params.installedItems;
        this._devItems = params.devItems;
        this._removableItems = params.removableItems;
        this._freeSpaceBuffer = params.freeSpaceBuffer;
        this._additionalSizeRequirements = params.additionalSizeRequirements;
        var dev = gApplication.deviceManager.activeDevice;
        var args =
        {
            deviceCode: dev.deviceCode,
            deviceSerial: dev.serial,
            deviceModel: dev.model.id,
            deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
            deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
            deviceNavcoreVersion : dev.versionNavCore,
            deviceNavcoreBuild : dev.buildNumberNavCore,
            publicBeta : prefService().getBoolPref("tomtom.app.showBetaVersions")
        };

        var me = this;
        addSubscriptionsRPCArgs(args);
        this.networkCall(rpc.call("shop", "getAccountLicensedContent",
            args, null, RPC.METHOD_GET & ~RPC.USE_CACHE,
            function(result)
            {
                let items = gApplication.itemFactory.createItemListFromServer(result);
                me._zones = [];
                if (items.length > 0)
                {
                    for each (let item in items)
                    {
                        if (item.basemap && item.basemap == me._basemap.basemap)
                        {
                            if (item.idstr != me._basemap.idstr)
                                me._zones.push(item);
                            else
                                me._basemapServerModel = item;
                        }
                    }                
                }
                me._zones.unshift(me._basemap);

                if (me._zones.length <= 1)
                    throw new InformativeException(me._stringBundle.GetStringFromName("zones.notfound"));

                if (params.insideInstallFlow)
                    me.showFlavoursIntroScreen();
                else
                    me.showFlavoursChoice();
            },
            makeCallback(this, function(e)
            {
                if (params.insideInstallFlow)
                {
                    unimportantError(e);
                    this.subtaskDone(this._basemap);
                }
                else
                    errorAbortTask(e);
            })));
    },
showFlavoursIntroScreen : function()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("mapFlavourIntroScreen"),
            null,
            makeCallback(this, this.flavourIntroScreenDone),
            null,
            makeCallback(this, this.showFlavoursChoice)
            );
    },
flavourIntroScreenDone : function(page)
    {
        page.inputDone();
    },
showFlavoursChoice : function()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("mapFlavourChoice"),
                  { maps : this._zones,
                    basemapServerModel : this._basemapServerModel,
                    basemap : this._basemap,
                    installedItems : this._installedItems,
                    devItems : this._devItems,
                    freeSpaceBuffer : this._freeSpaceBuffer,
                    additionalSizeRequirements :this._additionalSizeRequirements },
            makeCallback(this, this.showFlavoursChoiceAsync),
            null,
            makeCallback(this, this.showFlavoursChoiceDone)
            );
    },
showFlavoursChoiceAsync : function(page)
    {
        page.inputDone();
    },
showFlavoursChoiceDone : function(map)
    {
        this.subtaskDone(map);
    },
_willFullmapPotentiallyFit : function(fullmap)
    {
        let installedItems = this._installedItems.concat(fullmap);

        if (!this._removableItems)
        {
            this._removableItems = new ttItemList();
            this._task.addCleanupHandler(makeCallback(this, function() {
                                                          this._removableItems.destructor();
                                                      }));
            this._removableItems.addFilter(new ttNonRemovableFilter(installedItems));
            this._removableItems.addItemList(this._devItems);
        }
        let fullmapPotentiallyFits = true;

        let itemsPotentiallyFitByLocation = ttNavItem.willItemsFitByTargetLocation(
            installedItems,
            this._removableItems.contents,
            this._devItems.contents,
            this._additionalSizeRequirements,
            this._freeSpaceBuffer);

        let installTargets = ttNavItem.getItemsByTargetLocation([fullmap], this._devItems.contents);
        for (let target in installTargets)
        {
            fullmapPotentiallyFits = typeof itemsPotentiallyFitByLocation[target] == "undefined" ? true : itemsPotentiallyFitByLocation[target];

            if (!fullmapPotentiallyFits)
                break;
        }

        return fullmapPotentiallyFits;
    },

    __end : null
}
extend(MapFlavours, ttSubTask);
