/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ServerList()
{
    ttPage.apply(this, arguments);
}
ServerList.prototype =
{
    contentType : null,
    _selectedItem : null,
    _refresh : null,
    _sb : null,
    _sbTypes : null,
_sharingAllowed : null,
    _nextPageItem : null,
    _prevPageItem : null,
_devItems : null,

    inputOnLoad : function(args)
    {
        this._sb = E("strings");
        this._sbTypes = E("itemTypeStrings");
        this.contentType = args.contentType;
        this._refresh = args.refresh;
        this._sharingAllowed = args.sharingAllowed;

        var contentTypeName = this._sbTypes.getString(this.contentType);
        var contentTypeNamePlural = this._sbTypes.getString(this.contentType + "Plural");
        this.title = this._sb.getFormattedString("title", [contentTypeNamePlural]);

        let listEntry = gApplication.itemFactory.findSubtype("xmlTag", this.contentType);
        if (listEntry && listEntry.itemtypeEnum && gApplication.homeServices.isSingular(listEntry.itemtypeEnum))
            this.subtitle = this._sb.getString("subtitleSingleInstance");
        else
            this.subtitle = this._sb.getString("subtitle");
        this._wizard().setAttribute("contenttype", this.contentType);

        E("sortBy").value = args.sortOrder;
        E("filterBy").value = (args.recommendationsOnly ? "__recommended__" : "__all__");
            
        this._listbox = E("listbox");
        this._listbox.addObserver(this);
        this._listbox.addItemList(args.itemlist);

        var me = this;
        if (this._sharingAllowed)
        {
            this.networkCall(rpc.call("sharing", "getCategories",
                { contentType : this.contentType },
                null, RPC.METHOD_GET,
                function (result)
                {
                    var categories = [];
                    for each (var cat in result.category)
                    {
                        categories.push(
                            {
                                id : makeSafe.string(cat.@id),
                                name : makeSafe.string(cat.text())
                            });
                    };

                    me.populateCategories(categories);
                },
                unimportantError));
        }

        if (args.ratingAllowed)
        {
            var hiddencolumns = E("listbox").getAttribute("hiddencolumns");
            E("listbox").setAttribute("hiddencolumns", hiddencolumns.replace(/rating/, ""));

            E("sortByRatingOption").hidden = false;
        }

        E("filterBy").addEventListener("select", makeCallback(this, this.onFilterByChange), false);
        E("sortBy").addEventListener("select", makeCallback(this, this.refreshWithNewFilters), false);
        E("paginator").addEventListener("select", makeCallback(this, this.refreshList), false);
        E("search").addEventListener("command", makeCallback(this, this.onSearchStringChange), false);
        E("searchFor").addEventListener("keypress",
            function (aEvent)
            {
                if (aEvent.keyCode == CI.nsIDOMKeyEvent.DOM_VK_RETURN ||
                    aEvent.keyCode == CI.nsIDOMKeyEvent.DOM_VK_ENTER)
                {
                    aEvent.preventDefault();
                    me.onSearchStringChange();
                }
            },
            false);
if (args.search)
            E("searchFor").value = args.search;
    },
inputStart : function(data)
    {
        this._devItems = data.devItems;
    },

    inputDone : function(params)
    {
        if (params.sharingEnabled && this._sharingAllowed)
        {
            var shareButton = E("share-button");
            shareButton.setAttribute("value", this._sb.getString("shareButton.generic"));
            shareButton.hidden = false;
            E("list-separator").hidden = false;

            if (params.currentPage != null && params.numPages != null)
            {
                E("paginator").currentPage = params.currentPage;
                E("paginator").numPages = params.numPages;
                var listbox = E("listbox");
                var me = this;
                if (params.currentPage > 1)
                {
                    this._prevPageItem = document.createElementNS(kNS_XUL, "ttlistboxitem");
                    this._prevPageItem.addEventListener("click", function()
                    {
                        E("paginator").currentPage--;
                        me.refreshList();
                    }, false);
                    listbox.addItem(this._prevPageItem, listbox.firstChild);

                    var link = document.createElementNS(kNS_XUL, "description");
                    link.setAttribute("class", "link");
                    link.setAttribute("value", this._sb.getString("prevPage.label"));
                    this._prevPageItem.addMixedCell(link);
                }
                if (params.currentPage < params.numPages)
                {
                    this._nextPageItem = document.createElementNS(kNS_XUL, "ttlistboxitem");
                    this._nextPageItem.addEventListener("click", function()
                    {
                        E("paginator").currentPage++;
                        me.refreshList();
                    }, false);
                    listbox.addItem(this._nextPageItem);

                    var link = document.createElementNS(kNS_XUL, "description");
                    link.setAttribute("class", "link");
                    link.setAttribute("value", this._sb.getString("nextPage.label"));
                    this._nextPageItem.addMixedCell(link);
                }
            }
        }

        E("paginator").disabled = false;
        E("sortBy").disabled = false;
        E("filterBy").disabled = false;
        E("searchFor").disabled = false;
        E("search").disabled = false;
    },

    addedListItem : function(listitem)
    {
        var me = this;
        var model = listitem.modelitem;

        if (model instanceof ttMap)
        {
            let maptype = model.mapType;
            let maphierarchyloc = model.locationType == 1 || model.locationType == 4 || model.locationType == 6;
            if (model && maptype == 2 && maphierarchyloc)
                listitem.addMapZoneLink(makeCallback(this, this.changeMapFlavour));

            if (maptype != 0)
                listitem.processHierarchy();
        }

        if (!model.isServer)
        {
            if (model.locationType != 1)
            {
                listitem.addButton(this._sb.getString("addgoButton"), function(listitem)
                {
                    me._selectedItem = listitem.modelitem;
                    me.continue();
                });
            }
        }
        else
        {
            if (model.basemapRef)
                return;

            if (!model.price)
            {
return;
            }
            if (model.price.free)
            {
                listitem.addButton(this._sb.getString("getButton"), function(listitem)
                {
                    me._selectedItem = listitem.modelitem;
                    me.continue();
                });
            }
            else
            {
                if (gApplication.cart.itemInCart(listitem.modelitem))
                {
                    listitem.disabled = true;
                    listitem.addButton(this._sb.getString("inCartButton"), null);
                }
                else
                {
                    listitem.addButton(this._sb.getString("buyButton"), function(listitem)
                    {
                        gApplication.cart.addItem(listitem.modelitem);
                        me._selectedItem = listitem.modelitem;
                        me.continue();
                    });
                }
            }
        }
    },
    _ignoreFilterChange : false,

    onFilterByChange : function()
    {
        if (this._ignoreFilterChange)
            return;
        var filter = E("filterBy").value;
        if (filter && filter.indexOf("XXX") == 0)
            return;
        E("searchFor").value = "";

        this.refreshWithNewFilters();
    },

    onSearchStringChange : function()
    {
        if (/\S/.test(E("searchFor").value))
        {
            this._ignoreFilterChange = true;
            try
            {
                E("filterBy").value = "__all__";
            }
            finally
            {
                this._ignoreFilterChange = false;
            }
        }

        this.refreshWithNewFilters();
    },

    refreshWithNewFilters : function()
    {
        E("paginator").currentPage = 1;
        this.refreshList();
    },

    refreshList : function()
    {
        try {
            if (this._prevPageItem)
            {
                E("listbox").removeItem(this._prevPageItem);
                this._prevPageItem = null;
            }
            if (this._nextPageItem)
            {
                E("listbox").removeItem(this._nextPageItem);
                this._nextPageItem = null;
            }
            E("paginator").disabled = true;
            E("filterBy").disabled = true;
            E("sortBy").disabled = true;
            E("searchFor").disabled = true;
            E("search").disabled = true;
            E("listbox").focus();
            var params = {};
            var filter = E("filterBy").value;
            params.recommendationsOnly = (filter == "__recommended__");
            if (filter != "__recommended__" && filter != "__all__" &&
                filter && filter.indexOf("XXX") != 0)
            {
                params.category = filter;
                if (this.contentType == "voice")
                    params.language = filter;
                else
                    params.language = "";
            }
            else
            {
                params.category = "";
                params.language = "";
            }
            params.sortOrder = E("sortBy").value;
            params.currentPage = E("paginator").currentPage;
            params.search = E("searchFor").value.trim();

            page._refresh(params);
        } catch (e) { errorNonFatal(e); }
    },

    populateCategories : function (categories)
    {
        var catList = E("filterBy");

        for (var i = 0; i < categories.length; i++)
            catList.appendItem(categories[i].name, categories[i].id);
    },

    shareContent : function()
    {
        var sharingURI = "chrome://tthome/content/ui/dashboard/sharing.xul?return=chrome://tthome/content/ui/dashboard/mainDashboard.xul";
        sharingURI += "&contentType=" + this.contentType;
        top.gMainWindow.loadContent(sharingURI);
    },

    changeMapFlavour : function(listitem)
    {
        top.gMainWindow.currentTask().trackDialog(
            top.gMainWindow.dialogs.openDialogAsPage("chrome://tthome/content/ui/dialogs/taskDialog/taskDialog.xul", {
                url: "chrome://tthome/content/ui/task/mapFlavours/mapFlavours.xul",
                taskParams: { map: listitem.modelitem, devItems : this._devItems, resultCallback: makeCallback(this, this.setMapFlavour, listitem.modelitem) }
            }));
    },

    setMapFlavour : function(origMap, flavour)
    {
        if (origMap.idstr == flavour.idstr)
            return;

        this._selectedItem = flavour;
        this.continue();
    },

    result : function()
    {
        return [this._selectedItem];
    }
}
extend(ServerList, ttPage);
window.page = new ServerList();
