/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function SizeWarning()
{
    ttDialog.call(this, "footer");
}
SizeWarning.prototype =
{
    onLoad: function(params)
    {
        var newItems = params.newItems;
        var bundle = E("stringBundle");

        if (gApplication.deviceManager.activeDevice.hasCapability("SDSlot"))
        {
            E("subtitle").subtitle = bundle.getString("page.subtitle.SD");

            E("changeinstall").hidden = false;
            E("emptymemorycard").hidden = false;
        }
        else
        {
            E("subtitle").subtitle = bundle.getString("page.subtitle.noSD");
        }

        var sizeCheck = checkSizes();
        if (sizeCheck.mustSwap)
        {
            E("removeitems.text").textContent = bundle.getFormattedString("replaceitem.text",
                [sizeCheck.largestCartItemName, sizeCheck.largestDeviceItemName]);
            E("removeitems").hidden = false;
        }
        else if (sizeCheck.cartTotalSize < sizeCheck.maxSize)
        {
            E("removeitems.text").textContent = bundle.getFormattedString("removeitems.text",
                [ttItem.sizeBytesToMB(sizeCheck.missingSize)]);
            E("removeitems").hidden = false;
        }
    },

    cancel : function()
    {
        this.close(2);
    },

    continue : function()
    {
        this.close(1);
    },

    changeDevice : function()
    {
        this.close(3);
    },

    __end : null
}
extend(SizeWarning, ttDialog);
var dialog = new SizeWarning();


function checkSizes()
{
    var sizeCheck = {
        cartTotalSize: 0,
        largestCartItemSize: 0,
        largestCartItemName: "",
        largestDeviceItemSize: 0,
        largestDeviceItemName: "",
        missingSize: 0,
        freeSize: 0,
        maxSize: 0,

        canSwap: false,
        mustSwap: false
    };

    for each (item in gApplication.cart.contentsFlat)
    {
        sizeCheck.cartTotalSize += item.size;
        if (item.size > sizeCheck.largestCartItemSize)
        {
            sizeCheck.largestCartItemSize = item.size;
            sizeCheck.largestCartItemName = item.name;
        }
    }

    var target = gApplication.deviceManager.activeInstallLocation;
    var smallestVoiceSize = 0;
    var navCoreSize = 0;
    for each (item in gApplication.itemFactory.createItemListFromDLL(target.deviceNavItems()))
    {
        if (item.size > sizeCheck.largestDeviceItemSize)
        {
            sizeCheck.largestDeviceItemSize = item.size;
            sizeCheck.largestDeviceItemName = item.name;
        }
        if (item instanceof ttProgram)
        {
            navCoreSize = item.size;
        }
        if (item instanceof ttVoice)
        {
            if (smallestVoiceSize == 0 || smallestVoiceSize > item.size)
                smallestVoiceSize = item.size;
        }
    }
    sizeCheck.maxSize = target.sizeInBytesTotal;
    if (navCoreSize)
    {
        sizeCheck.maxSize -= 1.1 * (navCoreSize + smallestVoiceSize);
    }
    sizeCheck.missingSize = sizeCheck.cartTotalSize - target.sizeInBytesFree;
    sizeCheck.freeSize = target.sizeInBytesFree;
    sizeCheck.mustSwap =
        sizeCheck.maxSize - sizeCheck.largestDeviceItemSize < sizeCheck.largestCartItemSize
        && target.sizeInBytesFree + sizeCheck.largestDeviceItemSize > sizeCheck.cartTotalSize;

    return sizeCheck;
}
