/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function SelectInstall()
{
    ttPage.apply(this, arguments);
}
SelectInstall.prototype =
{
_restartUpdateTaskOnLoginChange : false,

    _selectedItem : null,
_selectedItems : null,
_devItems : null,
_devMapZoneItems : null,
get _selectedItemsMap()
    {
        var result = {__proto__: null};
        for each (var item in this._selectedItems)
        {
            result[item.idurl] = true;
            result[item.idstrlong] = true;
        }
        return memoize(this, "_selectedItemsMap", result);
    },
_saveUncheckedItems : function()
    {
        var prefName = this._uncheckedItemsMapPrefName;
        if (prefName)
        {
            var items = this._listbox.listitems;
            var uncheckedItemsMap = this._uncheckedItemsMap;
            for each(let item in items)
            {
                if (!item.selected && !item.disabled)
                {
                    uncheckedItemsMap[item.modelitem.idurl] = true;
                }
                else
                {
                    delete uncheckedItemsMap[item.modelitem.idurl];
                }
            }
            try
            {
                var prefValue = Cc["@mozilla.org/supports-string;1"]
                    .createInstance(CI.nsISupportsString);
                prefValue.data = JSON.stringify(uncheckedItemsMap);
                prefService().setComplexValue(prefName, CI.nsISupportsString, prefValue);
            } catch (e) {
                unimportantError(e, "Can not store user unchecked items map into the preference");
            }
        }
    },
get _uncheckedItemsMapPrefName()
    {
        return memoize(this, "_uncheckedItemsMapPrefName", gApplication.login.isLoggedIn ? 'tomtom.update.uncheckeditems.' + gApplication.login.currentUsername : null);
    },
get _uncheckedItemsMap()
    {
        var prefName = this._uncheckedItemsMapPrefName;
        if (prefName)
        {
            try {
                return memoize(this, "_uncheckedItemsMap", JSON.parse(prefService().getComplexValue(prefName, CI.nsISupportsString).data));
            } catch (e) {}
        }
        return memoize(this, "_uncheckedItemsMap", {});
    },

    inputOnLoad : function(args)
    {
        this.allowContinue(false);
        this._listbox = E("listbox");
        this._listbox.addObserver(this);
        this._sb = E("stringbundle");

        if (args.silent)
        {
            this.title = this._sb.getString("automaticTitle");
            this.subtitle = this._sb.getString("automaticSubtitle");
        }

        this._restartUpdateTaskOnLoginChange = (args && "restartUpdateTaskOnLoginChange" in args && args.restartUpdateTaskOnLoginChange);
    },
inputStart : function(data)
    {
        this._listbox.addItemList(data.itemlist);
        this._devItems = data.devItems;
        this._devMapZoneItems = {__proto__: null};
        for each (let item in this._devItems.contents)
        {
            if (item instanceof ttMap && item.mapType == 2)
            {
                this._devMapZoneItems[item.idstrlong + ":_basemap" + item.basemap] = item;
            }
        }
        this._selectedItems = data.selectedItems;
        if (this._restartUpdateTaskOnLoginChange) {
            E("loginWarningContainer").hidden = gApplication.login.isLoggedIn;
        }
    },

    inputDone : function(args)
    {
        if (args.mapShareEnabled)
        {
            if (args.mapPatchesServerBusy && args.poiPatchesServerBusy)
            {
                E("bothPatchesServerBusy").hidden = false;
            }
            else
            {
                if (args.mapPatchesServerBusy)
                    E("mapPatchesServiceBusy").hidden = false;

                if (args.poiPatchesServerBusy)
                    E("poiPatchesServerBusy").hidden = false;
            }

            if (args.haveMapPatches)
            {
                var mapPatchItem = new ttMapShareMapPatches(
                    window.page._sb.getFormattedString("mapShareMapMoreInfo.title", [args.mapPatchesMap.name]),
                    window.page._sb.getString("mapShareMapMoreInfo.text"),
                    args.mapPatchesDownloadSize
                    );
                this._listbox.addModel(mapPatchItem);
            }
            if (args.havePoiPatches)
            {
                var poiPatchItem = new ttMapSharePOIPatches(
                    window.page._sb.getFormattedString("mapSharePOIMoreInfo.title", [args.mapPatchesMap.name]),
                    window.page._sb.getString("mapSharePOIMoreInfo.text"),
                    args.poiPatchesDownloadSize
                    );
                this._listbox.addModel(poiPatchItem);
            }

            if (args.haveMapUpload)
            {
                E("mapUpload").checked = true;

                E("mapUpload").addEventListener("click", function()
                    {
                        if (!this.disabled)
                            this.checked = !this.checked;
                    }, false);
                E("mapUpload").addEventListener("CheckboxStateChange", makeCallback(this, this.updateContinueButton), false);
            }
            else
            {
                E('mapUploadBox').hidden = true;
            }
        }

        var showUpload = (args.haveSafetycamUpload || args.haveMapUpload);
        E("uploadSeparator").hidden = !showUpload;
        E("uploadBox").hidden = !showUpload;

        if (args.haveSafetycamUpload)
        {
            E("safetycamUploadBox").hidden = false;
            E("safetycamUpload").checked = true;

            E("safetycamUpload").addEventListener("click", function()
                {
                    if (!this.disabled)
                        this.checked = !this.checked;
                }, false);
            E("safetycamUpload").addEventListener("CheckboxStateChange", makeCallback(this, this.updateContinueButton), false);
        }

        this.updateContinueButton();

        if (this.haveUpdates())
            this.subtitle = this._sb.getString("normalSubtitle");
        else
            this.subtitle = this._sb.getString("noUpdatesSubtitle");
    },

    addedListItem : function(listitem)
    {
        var uncheckedItemsMap = this._uncheckedItemsMap;
        var model = listitem.modelitem;
        if (!listitem.disabled)
        {
            if (model instanceof ttSafetyCams && !(model.idurl in uncheckedItemsMap))
                listitem.selected = (model.idurl in this._selectedItemsMap || model.idstrlong in this._selectedItemsMap);
            else
                listitem.selected = !(model.idurl in uncheckedItemsMap);
        }

        if (model instanceof ttMap)
        {
            let maptype = model.mapType;
            if (model.isServer && maptype == 2)
            {
                listitem.addMapZoneLink(makeCallback(this, this.changeMapFlavour));
                let key = model.idstrlong + ":_basemap" + model.basemap
                if (key in this._devMapZoneItems)
                {
                    if (this._devMapZoneItems[key].locationType == 1)
                        listitem.changeLocation(this._devMapZoneItems[key].sourceDLL.installLocation);
                }
            }
            if (maptype != 0)
                listitem.processHierarchy();
        }

        if (model.basemapRef)
        {
            let enableCheckbox = (model.mapType == 2) ? true : false;
            listitem.addToggleHierarchyButton(makeCallback(this, this.hierarchyCheckSelect),
                                               enableCheckbox);
        }
        else
        {
            listitem.addToggleButton(null, null,
                                     makeCallback(this, this.updateContinueButton),
                                     makeCallback(this, this.updateContinueButton));
        }
    },

    hierarchyCheckSelect : function(selectedItem)
    {
        this.updateContinueButton();
    },

    changeMapFlavour : function(listitem)
    {
        top.gMainWindow.currentTask().trackDialog(
            top.gMainWindow.dialogs.openDialogAsPage("chrome://tthome/content/ui/dialogs/taskDialog/taskDialog.xul", {
                url: "chrome://tthome/content/ui/task/mapFlavours/mapFlavours.xul",
                taskParams: { map: listitem.modelitem, devItems : this._devItems, resultCallback: makeCallback(this, this.setMapFlavour, listitem) }
            }));
    },

    setMapFlavour : function(origItem, newMap)
    {
        let origMap = origItem.modelitem;
        if (origMap.idstr == newMap.idstr)
            return;

        let listbox = E("listbox");
        let v = origItem.getAttribute("value");
        let newItem = null;

        if (newMap.mapType == 1)
        {
            newItem = listbox.getItemByValue(v, origItem);
            listbox.hierarchyCheckSelect(newItem);
        }
        else
        {
            let parentItem = origItem.previousSibling;
            if (parentItem.getAttribute("value") == origItem.getAttribute("value"))
                listbox.removeItem(parentItem);
            newItem = listbox.addModel(newMap, origMap);
            newMap.basemapRef = origMap.basemapRef;
            listbox.removeItem(origItem);
            let newZoneItem = listbox.updateModel(newMap);
            newZoneItem.selected = false;
            listbox.hierarchyCheckSelect(newZoneItem);
        }
    },

    updateContinueButton : function()
    {
        this.allowContinue(this.haveUpdates());
    },

    haveUpdates : function()
    {
        return this._listbox.selectedModelitems != 0 ||
               E("mapUpload").checked || E("safetycamUpload").checked;
    },

    result : function()
    {
        this._saveUncheckedItems();
        var result = new Object();
        result.items = this._listbox.selectedModelitems;
        result.getMapPatches = false;
        result.getPOIPatches = false;
        for (var i = 0; i < result.items.length; i++)
        {
            if (result.items[i] instanceof ttMapShareMapPatches)
            {
                result.getMapPatches = true;
                result.items.splice(i--, 1);
            }
            else if (result.items[i] instanceof ttMapSharePOIPatches)
            {
                result.getPOIPatches = true;
                result.items.splice(i--, 1);
            }
        }

        result.doMapUpload = E("mapUpload").checked;
        result.doSafetycamUpload = E("safetycamUpload").checked;
        return result;
    },

    loginWarningLogIn: function()
    {
        top.gMainWindow.goLogin();
    }
}
extend(SelectInstall, ttPage);
window.page = new SelectInstall();

function mapShareUploadMoreInfo()
{
    ttMessageService().alert(
        window.page._sb.getString("mapShareUploadMoreInfo.title"),
        window.page._sb.getString("mapShareUploadMoreInfo.text"));
}

function safetycamUploadMoreInfo()
{
    ttMessageService().alert(
        window.page._sb.getString("safetycamUploadMoreInfo.title"),
        window.page._sb.getString("safetycamUploadMoreInfo.text"));
}
